# -*- coding: utf-8 -*-
"""
 
 This file is part of oe3d (www.oe3d.at).

 oe3d is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 oe3d is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with oe3d.  If not, see <http://www.gnu.org/licenses/>.

 Author(s): Gerhard Summer (gerhard.summer@rechenraum.com) 
            Simon Flöry (simon.floery@rechenraum.com)
            

"""
import os
import ConfigParser
import oe3d
import numpy as np


###############################################################################

def neighbors (resultatpfad, resultatpfadneu):
	
    Config = ConfigParser.ConfigParser()
    Config.read('./configfile.txt')
    
    Ol=Config.getint("compute_all", "Overlap")
    liste=os.listdir(resultatpfad)
    
    rnummax=0
    cnummax=0
    print(liste)
    for filen in liste:
        
        if int(filen[8])>rnummax:
            rnummax=int(filen[8])
        if int(filen[9])>cnummax:
            cnummax=int(filen[9])
    
    print rnummax
    print cnummax

    (corners,edges)=find_corners_and_edges(liste,rnummax,cnummax)
    
    print ''
    print'Corners: '
    print ''
    
    for c in corners :
        print c
    #print(corners)        
    
    print ''
    print'Edges'
    print ''
    
    for e in edges :
        print e
    
    #print(edges)       
            
    for e in edges:
        
        firstfn=e[0]       
        secondfn=e[1]
    
        verticaledge=False
        horizontaledge=False    
        
        listeneu=os.listdir(resultatpfadneu)
        
        if np.abs(int(firstfn[8])-int(secondfn[8]))==0:
            verticaledge=True
        else:
            horizontaledge=True        
            
        if verticaledge:
                  
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
            
            data1OL=data1rs[2*Ol+1:len(data1rs)-2*Ol-1,(len(data1rs)-2*Ol-1):len(data1rs)]
            data2OL=data2rs[2*Ol+1:len(data1rs)-2*Ol-1,0:2*Ol+1]        
            #print(shape(data1OL))
            #print(data2OL)
            datanew=np.zeros(np.shape(data1OL))        
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(j)/np.shape(data1OL)[1]
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
                    #print datanew[i][j]
            data1rs[2*Ol+1:len(data1rs)-2*Ol-1,(len(data1rs)-2*Ol-1):len(data1rs)]=datanew
            data2rs[2*Ol+1:len(data1rs)-2*Ol-1,0:2*Ol+1]=datanew
            
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
            
            
        if horizontaledge:    
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
            
            data1OL=data1rs[len(data1rs)-2*Ol-1:len(data1rs),2*Ol+1:len(data1rs)-2*Ol-1]
            data2OL=data2rs[0:2*Ol+1,2*Ol+1:len(data1rs)-2*Ol-1]
                    
            
            #print(shape(data1OL))
            #print(shape(data2OL))
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(i)/len(data1OL[:])
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
            data1rs[len(data1rs)-2*Ol-1:len(data1rs),2*Ol+1:len(data1rs)-2*Ol-1]=datanew
            data2rs[0:2*Ol+1,2*Ol+1:len(data1rs)-2*Ol-1]=datanew
            
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
    
            
            
    
    
    for c in corners:
        listeneu=os.listdir(resultatpfadneu)    
        voidcount=0        
        twocorners=False
        threecorners=False
        fourcorners=False    
        for d in range(len(c)):
             if c[d]=='void':
                voidcount+=1
        if voidcount == 2:
            twocorners=True
        elif voidcount == 1:
            threecorners=True
        elif voidcount == 0:
            fourcorners=True
    
        horizontaledgeleft=False
        horizontaledgeright=False
        verticaledgeup=False
        verticaledgelow=False   
        
        if twocorners:
            if (c[0]=='void' and c[1]=='void'):
                firstfn=c[2]
                secondfn=c[3]
                horizontaledgeleft=True
            if (c[0]=='void' and c[3]=='void'):
                firstfn=c[1]
                secondfn=c[2]
                verticaledgelow=True
            if (c[1]=='void' and c[2]=='void'):
                firstfn=c[0]
                secondfn=c[3]
                verticaledgeup=True
            if (c[2]=='void' and c[3]=='void'):
                firstfn=c[1]
                secondfn=c[0]
                horizontaledgeright=True
         
        if threecorners:
           if c[0]=='void':
               firstfn='AVERAGE'
               secondfn=c[1]
               thirdfn=c[2]
               fourthfn=c[3]
           if c[1]=='void':
               firstfn=c[0]
               secondfn='AVERAGE'
               thirdfn=c[2]
               fourthfn=c[3]
           if c[2]=='void':
               firstfn=c[0]
               secondfn=c[1]
               thirdfn='AVERAGE'
               fourthfn=c[3]
           if c[3]=='void':    
               firstfn=c[0]
               secondfn=c[1]
               thirdfn=c[2]
               fourthfn='AVERAGE'
               
        if fourcorners:     
            firstfn=c[0]
            secondfn=c[1]
            thirdfn=c[2]
            fourthfn=c[3]
    
           
                
        if horizontaledgeleft:
    
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)    
            
            data1OL=data1rs[len(data1rs)-2*Ol-1:len(data1rs),0:2*Ol+1]    
            data2OL=data2rs[0:2*Ol+1,0:2*Ol+1]    
                   
            
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(i)/len(data1OL[:])
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
            
            data1rs[len(data1rs)-2*Ol-1:len(data1rs),0:2*Ol+1]=datanew
            data2rs[0:2*Ol+1,0:2*Ol+1]=datanew        
                
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
      
                
                
        if horizontaledgeright:
    
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
            
            data1OL=data1rs[len(data1rs)-2*Ol-1:len(data1rs),-2*Ol-1:len(data1rs)]    
            data2OL=data2rs[0:2*Ol+1,-2*Ol-1:len(data2rs)]    
                     
            
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(i)/len(data1OL[:])
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
            
            data1rs[len(data1rs)-2*Ol-1:len(data1rs),-2*Ol-1:len(data1rs)]=datanew
            data2rs[0:2*Ol+1,-2*Ol-1:len(data2rs)]=datanew        
                
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
    
                
        if verticaledgeup:
            
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)        
                
            data1OL=data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]
            data2OL=data2rs[0:2*Ol+1,0:2*Ol+1]
            
            
            
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(j)/len(data1OL[:])
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
                
            data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]=datanew   
            data2rs[0:2*Ol+1,0:2*Ol+1]=datanew
            
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
            
            
        if verticaledgelow:    
            
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)   
            
            data1OL=data1rs[-2*Ol-1:len(data1rs),-2*Ol-1:len(data1rs)]
            data2OL=data2rs[-2*Ol-1:len(data1rs),0:2*Ol+1]
                        
            
            
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    w=1-float(j)/len(data1OL[:])
                    datanew[i][j]=w*data1OL[i][j]+(1-w)*data2OL[i][j]
            
            data1rs[-2*Ol-1:len(data1rs),-2*Ol-1:len(data1rs)]=datanew
            data2rs[-2*Ol-1:len(data1rs),0:2*Ol+1]=datanew
            
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
            
            
            
        if fourcorners:    
            
            (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
            (data3rs,data4rs,data3,data4)=load_and_reshape_files(thirdfn,fourthfn,listeneu,resultatpfad,resultatpfadneu)
            
            data1OL=data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]
            data2OL=data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data1rs)]
            data3OL=data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]
            data4OL=data4rs[0:2*Ol+1,0:2*Ol+1]
          
            
            datanew=np.zeros(np.shape(data1OL))
            for i in range(np.shape(data1OL)[0]):
                for j in range(np.shape(data1OL)[1]):
                    u=1-float(j)/len(data1OL[:])
                    v=1-float(i)/len(data1OL[:])
                    datanew[i][j]=v*(u*data2OL[i][j]+(1-u)*data3OL[i][j])+(1-v)*(u*data1OL[i][j]+(1-u)*data4OL[i][j])
                    
            data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]=datanew        
            data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data1rs)]=datanew        
            data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]=datanew       
            data4rs[0:2*Ol+1,0:2*Ol+1]=datanew
            
            reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
            reshape_and_write_files(data1,data2,thirdfn,fourthfn,data3rs,data4rs,Ol,rnummax,cnummax,resultatpfadneu)
            
            
        if threecorners:    
            
            if firstfn=='AVERAGE':
                (data2rs,data3rs,data2,data3)=load_and_reshape_files(secondfn,thirdfn,listeneu,resultatpfad,resultatpfadneu)
                (data4rs,data4rs,data4,data4)=load_and_reshape_files(fourthfn,fourthfn,listeneu,resultatpfad,resultatpfadneu)
            
                data2OL=data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data1rs)]
                data3OL=data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]
                data4OL=data4rs[0:2*Ol+1,0:2*Ol+1]
            
                data1OL=np.zeros(np.shape(data1OL))
                datanew=np.zeros(np.shape(data1OL))
                for i in range(np.shape(data1OL)[0]):
                    for j in range(np.shape(data1OL)[1]):
                        data1OL[i][j]=(data2OL[i][j]+data3OL[i][j]+data4OL[i][j])/3
                        u=1-float(j)/len(data1OL[:])
                        v=1-float(i)/len(data1OL[:])
                        datanew[i][j]=v*(u*data2OL[i][j]+(1-u)*data3OL[i][j])+(1-v)*(u*data1OL[i][j]+(1-u)*data4OL[i][j])
            
                data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data1rs)]=datanew        
                data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]=datanew       
                data4rs[0:2*Ol+1,0:2*Ol+1]=datanew
            
                reshape_and_write_files(data1,data2,secondfn,thirdfn,data2rs,data3rs,Ol,rnummax,cnummax,resultatpfadneu)
                reshape_and_write_files(data1,data2,fourthfn,fourthfn,data4rs,data4rs,Ol,rnummax,cnummax,resultatpfadneu)
            
            
            if secondfn=='AVERAGE':
                
                (data1rs,data3rs,data1,data3)=load_and_reshape_files(firstfn,thirdfn,listeneu,resultatpfad,resultatpfadneu)
                (data4rs,data4rs,data4,data4)=load_and_reshape_files(fourthfn,fourthfn,listeneu,resultatpfad,resultatpfadneu)
            
                data1OL=data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]
                data3OL=data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]
                data4OL=data4rs[0:2*Ol+1,0:2*Ol+1]
             
                data2OL=np.zeros(np.shape(data1OL))
                datanew=np.zeros(np.shape(data1OL))
                for i in range(np.shape(data1OL)[0]):
                    for j in range(np.shape(data1OL)[1]):
                        data2OL[i][j]=(data1OL[i][j]+data3OL[i][j]+data4OL[i][j])/3
                        u=1-float(j)/len(data1OL[:])
                        v=1-float(i)/len(data1OL[:])
                        datanew[i][j]=v*(u*data2OL[i][j]+(1-u)*data3OL[i][j])+(1-v)*(u*data1OL[i][j]+(1-u)*data4OL[i][j])
                        
                
                data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]=datanew        
                data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]=datanew       
                data4rs[0:2*Ol+1,0:2*Ol+1]=datanew
            
                reshape_and_write_files(data1,data2,firstfn,thirdfn,data1rs,data3rs,Ol,rnummax,cnummax,resultatpfadneu)
                reshape_and_write_files(data1,data2,fourthfn,fourthfn,data4rs,data4rs,Ol,rnummax,cnummax,resultatpfadneu)
                
                
            if thirdfn=='AVERAGE':
                (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
                (data4rs,data4rs,data4,data4)=load_and_reshape_files(fourthfn,fourthfn,listeneu,resultatpfad,resultatpfadneu)
            
                data1OL=data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]
                data2OL=data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data2rs)]
                data4OL=data4rs[0:2*Ol+1,0:2*Ol+1]
            
                data3OL=np.zeros(np.shape(data1OL))
                datanew=np.zeros(np.shape(data1OL))
                for i in range(np.shape(data1OL)[0]):
                    for j in range(np.shape(data1OL)[1]):
                        data3OL[i][j]=(data1OL[i][j]+data2OL[i][j]+data4OL[i][j])/3
                        u=1-float(j)/len(data1OL[:])
                        v=1-float(i)/len(data1OL[:])
                        datanew[i][j]=v*(u*data2OL[i][j]+(1-u)*data3OL[i][j])+(1-v)*(u*data1OL[i][j]+(1-u)*data4OL[i][j])
            
                data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]=datanew        
                data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data2rs)]=datanew       
                data4rs[0:2*Ol+1,0:2*Ol+1]=datanew
            
                reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
                reshape_and_write_files(data1,data2,fourthfn,fourthfn,data4rs,data4rs,Ol,rnummax,cnummax,resultatpfadneu)
                    
                    
            if fourthfn=='AVERAGE':
                (data1rs,data2rs,data1,data2)=load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu)
                (data3rs,data3rs,data3,data3)=load_and_reshape_files(thirdfn,thirdfn,listeneu,resultatpfad,resultatpfadneu)
            
                data1OL=data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]
                data2OL=data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data2rs)]
                data3OL=data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]
            
                data4OL=np.zeros(np.shape(data1OL))
                datanew=np.zeros(np.shape(data1OL))
                for i in range(np.shape(data1OL)[0]):
                    for j in range(np.shape(data1OL)[1]):
                        data4OL[i][j]=(data1OL[i][j]+data2OL[i][j]+data3OL[i][j])/3
                        u=1-float(j)/len(data1OL[:])
                        v=1-float(i)/len(data1OL[:])
                        datanew[i][j]=v*(u*data2OL[i][j]+(1-u)*data3OL[i][j])+(1-v)*(u*data1OL[i][j]+(1-u)*data4OL[i][j])
            
                data1rs[0:2*Ol+1,-2*Ol-1:len(data1rs)]=datanew        
                data2rs[-2*Ol-1:len(data2rs),-2*Ol-1:len(data2rs)]=datanew       
                data3rs[-2*Ol-1:len(data2rs),0:2*Ol+1]=datanew
            
                reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu)
                reshape_and_write_files(data1,data2,thirdfn,thirdfn,data3rs,data3rs,Ol,rnummax,cnummax,resultatpfadneu)   
                
    return (rnummax,cnummax)            

##############################################################################

def find_neighbor(filen,dirct,rnummax,cnummax):
    
    
    laenge=int(filen[4])*100+int(filen[5])*10+int(filen[6])
    breite=int(filen[1])*10+int(filen[2])
    rnum=int(filen[8])
    cnum=int(filen[9])
    
    if dirct=='NW':
        if rnum==0:
            breiten=breite+1
            rnumn=rnummax
        else:
            breiten=breite            
            rnumn=rnum-1
        if cnum==0:
            laengen=laenge-1
            cnumn=cnummax
        else:
            laengen=laenge            
            cnumn=cnum-1
            
    elif dirct=='N':
        if rnum==0:
            breiten=breite+1
            rnumn=rnummax
        else:
            breiten=breite
            rnumn=rnum-1
        cnumn=cnum
        laengen=laenge        
        
    elif dirct=='NO':
        if rnum==0:
            breiten=breite+1
            rnumn=rnummax
        else:
            breiten=breite            
            rnumn=rnum-1
        if cnum==cnummax:
            laengen=laenge+1
            cnumn=0
        else:
            laengen=laenge
            cnumn=cnum+1
            
    elif dirct=='O':
        rnumn=rnum
        breiten=breite
        if cnum==cnummax:
            laengen=laenge+1
            cnumn=0
        else:
            laengen=laenge
            cnumn=cnum+1

    elif dirct=='SO':
        if rnum==rnummax:
            breiten=breite-1
            rnumn=0
        else:
            breiten=breite
            rnumn=rnum+1
        if cnum==cnummax:
            laengen=laenge+1
            cnumn=0
        else:
            laengen=laenge
            cnumn=cnum+1
            
    elif dirct=='S':        
        if rnum==rnummax:
            breiten=breite-1
            rnumn=0
        else:
            breiten=breite
            rnumn=rnum+1
        cnumn=cnum
        laengen=laenge
    
    elif dirct=='SW':
        if rnum==rnummax:
            breiten=breite-1
            rnumn=0
        else:
            breiten=breite
            rnumn=rnum+1
        if cnum==0:
            laengen=laenge-1
            cnumn=cnummax
        else:
            laengen=laenge            
            cnumn=cnum-1

    elif dirct=='W':
        rnumn=rnum
        breiten=breite
        if cnum==0:
            laengen=laenge-1
            cnumn=cnummax
        else:
            laengen=laenge            
            cnumn=cnum-1            
            
            
    filename='N'+str(breiten)+'E'+str(laengen).zfill(3)+'_'+str(rnumn)+str(cnumn)+'.tif'
    return filename    
                

##############################################################################

def find_corners_and_edges(liste,rnummax,cnummax):
    



    corners=set()
    edges=set()
    corner=()
    edge=()
    for filen in liste:    
        
        neighbors=np.zeros(8, dtype=bool)
        
        NWname=find_neighbor(filen,'NW',rnummax,cnummax)
        Nname=find_neighbor(filen,'N',rnummax,cnummax)
        NOname=find_neighbor(filen,'NO',rnummax,cnummax)
        Oname=find_neighbor(filen,'O',rnummax,cnummax)
        SOname=find_neighbor(filen,'SO',rnummax,cnummax)
        Sname=find_neighbor(filen,'S',rnummax,cnummax)
        SWname=find_neighbor(filen,'SW',rnummax,cnummax)
        Wname=find_neighbor(filen,'W',rnummax,cnummax)
          
          
        
        neighborNW=(NWname in liste)
        neighborN=(Nname in liste)
        neighborNO=(NOname in liste)
        neighborO=(Oname in liste)    
        neighborSO=(SOname in liste)    
        neighborS=(Sname in liste)    
        neighborSW=(SWname in liste)    
        neighborW=(Wname in liste)
        
           
        
        
        #searching for upper left corners:
        
        if (neighborW and neighborNW and neighborN):
            corner=(Wname,NWname,Nname,filen)
        elif (neighborW and neighborNW):
            corner=(Wname,NWname,'void',filen)
        elif (neighborW and neighborN):
            corner=(Wname,'void',Nname,filen)
        elif (neighborNW and neighborN):
            corner=('void',NWname,Nname,filen)
        elif neighborW:
            corner=(Wname,'void','void',filen)
        elif neighborNW:
            corner=('void',NWname,'void',filen)
        elif neighborN:    
            corner=('void','void',Nname,filen)
        else:
            corner=()
        
        if corner!=():
            corners.add(corner)
        
        #searching for upper right corners
         
        if (neighborN and neighborNO and neighborO):
            corner=(filen,Nname,NOname,Oname)
        elif (neighborN and neighborNO):
            corner=(filen,Nname,NOname,'void')
        elif (neighborN and neighborO):
            corner=(filen,Nname,'void',Oname)
        elif (neighborNO and neighborO):
            corner=(filen,'void',NOname,Oname)
        elif neighborN:
            corner=(filen,Nname,'void','void')
        elif neighborNO:
            corner=(filen,'void',NOname,'void')
        elif neighborO:
            corner=(filen,'void','void',Oname)
        else:
            corner=()
        
        if corner!=():
            corners.add(corner)
        
        
        #searching for lower left corners    
        
    
        if (neighborS and neighborSW and neighborW):
            corner=(SWname,Wname,filen,Sname)
        elif (neighborS and neighborSW):
            corner=(SWname,'void',filen,Sname)
        elif (neighborS and neighborW):
            corner=('void',Wname,filen,Sname)
        elif (neighborSW and neighborW):
            corner=(SWname,Wname,filen,'void')
        elif neighborS:
            corner=('void','void',filen,Sname)
        elif neighborSW:
            corner=(SWname,'void',filen,'void')
        elif neighborW:
            corner=('void',Wname,filen,'void')
        else:
            corner=()
        
        if corner!=():
            corners.add(corner)    
            
        
        if neighborW:
            edge=(Wname,filen)
        if edge!=():
            edges.add(edge)
            
        if neighborN:
            edge=(Nname,filen)
        if edge!=():
            edges.add(edge)

    return (corners,edges)
    

#############################################################################

def find_longlat_from_filename(filename,rnummax,cnummax,Ol):



 if(filename[9]=='0'):
     l1=int(filename[4])*100+int(filename[5])*10+int(filename[6])-6400./10000-Ol/10000.       
 else:
     l1=int(filename[4])*100+int(filename[5])*10+int(filename[6])+int(filename[9])*3600./((cnummax+1)*10000)-Ol/10000.       
        
 if(int(filename[8])<(rnummax)):    
     b1=int(filename[1])*10+int(filename[2])+(rnummax-int(filename[8]))*3600./((rnummax+1)*10000)-Ol/10000.
 elif(int(filename[8])==(rnummax)):
     b1=int(filename[1])*10+int(filename[2])-6400./10000-Ol/10000.

 return(l1,b1)


#############################################################################

def load_and_reshape_files(firstfn,secondfn,listeneu,resultatpfad,resultatpfadneu):
    
    if firstfn in listeneu:
       data1=oe3d.fileloader(resultatpfadneu+'/'+firstfn)
    else:        
       data1=oe3d.fileloader(resultatpfad+'/'+firstfn)
    data1rs=np.reshape(data1[:,2],(((np.sqrt(np.shape(data1[:,2]))),(np.sqrt(np.shape(data1[:,2]))))))
        
    if secondfn in listeneu:    
       data2=oe3d.fileloader(resultatpfadneu+ '/'+secondfn)
    else:
       data2=oe3d.fileloader(resultatpfad+ '/'+secondfn)
    data2rs=np.reshape(data2[:,2],(((np.sqrt(np.shape(data2[:,2]))),(np.sqrt(np.shape(data2[:,2]))))))


    return (data1rs,data2rs,data1,data2)

#############################################################################


def reshape_and_write_files(data1,data2,firstfn,secondfn,data1rs,data2rs,Ol,rnummax,cnummax,resultatpfadneu):



    data1[:,2]=np.reshape(data1rs,((np.power(np.shape(data1rs)[0],2),)))
    data2[:,2]=np.reshape(data2rs,((np.power(np.shape(data2rs)[0],2),)))
        
    (l1,b1)=find_longlat_from_filename(firstfn,rnummax,cnummax,Ol)
    (l2,b2)=find_longlat_from_filename(secondfn,rnummax,cnummax,Ol)  
        
                 
    dx=(3600/(rnummax+1)+2*Ol)/10000.
    dy=(3600/(cnummax+1)+2*Ol)/10000.
    
    if not os.path.exists(resultatpfadneu+'/'+firstfn[0:7]+'/'):
        os.makedirs(resultatpfadneu+'/'+firstfn[0:7]+'/')
        
    if not os.path.exists(resultatpfadneu+'/'+secondfn[0:7]+'/'):
        os.makedirs(resultatpfadneu+'/'+secondfn[0:7]+'/')    
    
    oe3d.fileexporter(l1,b1,dx,dy,data1[:,2],resultatpfadneu+'/'+firstfn)       
    oe3d.fileexporter(l2,b2,dx,dy,data2[:,2],resultatpfadneu+'/'+secondfn)


############################################################################



    
