# -*- coding: utf-8 -*-
"""
 
 This file is part of oe3d (www.oe3d.at).

 oe3d is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 oe3d is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with oe3d.  If not, see <http://www.gnu.org/licenses/>.

 Author(s): Gerhard Summer (gerhard.summer@rechenraum.com) 
            Simon Flöry (simon.floery@rechenraum.com)
            

"""

import numpy as np
import oe3d
import ConfigParser
# This includes our cython module
import numberechnung

eps = 1e-8

Config = ConfigParser.ConfigParser()
Config.read('./configfile.txt')

fenstergr = Config.getint("num", "fenstergr")
numeingabepfad = Config.get("num", "numeingabepfad")
numausgabepfad = Config.get("num", "numausgabepfad")

X=[9,10,11,12,13,14,15,16,9,10,11,12,13,14,15,16,17,12,13,14,15,16,17,14,15,8,9,10,11,12,13,14,15,16,17,8,17,18,8,18,8,9,10,11,18,11,12,13,16,17,18,13,14,15,16]
Y=[46,46,46,46,46,46,46,46,47,47,47,47,47,47,47,47,47,48,48,48,48,48,48,49,49,45,45,45,45,45,45,45,45,45,45,46,46,46,47,47,48,48,48,48,48,49,49,49,49,49,49,50,50,50,50]

for i in range(25,len(X)):
     #print(str(X[i]))
     filenamestr = numeingabepfad + 'N' + str(Y[i]) + 'E' + str(X[i]).zfill(3) + '_num.hgt' 
     print 'Processing ' + filenamestr + ' ...'
     num = oe3d.fileloader(filenamestr)
     num = np.reshape(num[:,2], (3601,3601))
     numneu=np.zeros(np.shape(num))
     #Der nächste Schritt geschieht in der Datei numberechnung.pyx.
     numberechnung.fenster(num, numneu, fenstergr)
     
     if (numneu == 0).all():
		 print 'ALLES NULL'
		 exit()
     
     numneu[numneu<eps]=0
     # transforms numneu into an array
     numneu=np.reshape(numneu, -1)
     
     if (numneu > 1).any():
        print('numneu groesser 1 ---> FEHLER!')
        exit()
     
     # We can only store 16-bit signed integers in TIFs, that are integers
     # in [-32768, 32767]
     numneu=numneu*32767
     
     # write
     oe3d.fileexporter(X[i],Y[i],1,1,numneu,numausgabepfad + 'N' + str(Y[i]) + 'E' + str(X[i]).zfill(3) + '_numneu.tif')
     



################################################################################
             
                    
    
    
